diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/random-variable-stream-test-suite.cc ns-3.32/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.31/src/core/test/random-variable-stream-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/random-variable-stream-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -1583,61 +1382,32 @@
   double mu = 0.0;
   double sigma = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_lognormal_P (range[i + 1], mu, sigma) - gsl_cdf_lognormal_P (range[i], mu, sigma);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamLogNormalTestCase::DoRun (void)
+LogNormalTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<LogNormalRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
 
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<LogNormalRandomVariable> n = CreateObject<LogNormalRandomVariable> ();
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mu = 5.0;
   double sigma = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<LogNormalRandomVariable> x = CreateObject<LogNormalRandomVariable> ();
@@ -1645,13 +1415,7 @@
   x->SetAttribute ("Sigma", DoubleValue (sigma));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // log-normally distributed random variable is equal to
@@ -1664,52 +1428,49 @@
 
   // Test that values have approximately the right mean value.
   //
-  /// \todo This test fails sometimes if the required tolerance is less
-  /// than 3%, which may be because there is a bug in the
-  /// implementation or that the mean of this distribution is more
-  /// sensitive to its parameters than the others are.
-  double TOLERANCE = expectedMean * 3e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  /**
+   * \todo This test fails sometimes if the required tolerance is less
+   * than 3%, which may be because there is a bug in the
+   * implementation or that the mean of this distribution is more
+   * sensitive to its parameters than the others are.
+   */
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic log-normal distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamLogNormalAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic log-normal distribution random variable stream generator
+ */
+class LogNormalAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamLogNormalAntitheticTestCase ();
-  virtual ~RandomVariableStreamLogNormalAntitheticTestCase ();
+  // Constructor
+  LogNormalAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<LogNormalRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamLogNormalAntitheticTestCase::RandomVariableStreamLogNormalAntitheticTestCase ()
-  : TestCase ("Antithetic Log-Normal Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {3e-2};  
+};
 
-RandomVariableStreamLogNormalAntitheticTestCase::~RandomVariableStreamLogNormalAntitheticTestCase ()
+LogNormalAntitheticTestCase::LogNormalAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Log-Normal Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamLogNormalAntitheticTestCase::ChiSquaredTest (Ptr<LogNormalRandomVariable> n)
+LogNormalAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has mu equal to zero and sigma
   // equal to one, which are their default values for this
@@ -1717,65 +1478,31 @@
   double mu = 0.0;
   double sigma = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_lognormal_P (range[i + 1], mu, sigma) - gsl_cdf_lognormal_P (range[i], mu, sigma);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamLogNormalAntitheticTestCase::DoRun (void)
+LogNormalAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<LogNormalRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<LogNormalRandomVariable> n = CreateObject<LogNormalRandomVariable> ();
-
-      // Make this generate antithetic values.
-      n->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mu = 5.0;
   double sigma = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<LogNormalRandomVariable> x = CreateObject<LogNormalRandomVariable> ();
@@ -1786,13 +1513,7 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // log-normally distributed random variable is equal to
@@ -1805,52 +1526,49 @@
 
   // Test that values have approximately the right mean value.
   //
-  /// \todo This test fails sometimes if the required tolerance is less
-  /// than 3%, which may be because there is a bug in the
-  /// implementation or that the mean of this distribution is more
-  /// sensitive to its parameters than the others are.
-  double TOLERANCE = expectedMean * 3e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  /**
+   * \todo This test fails sometimes if the required tolerance is less
+   * than 3%, which may be because there is a bug in the
+   * implementation or that the mean of this distribution is more
+   * sensitive to its parameters than the others are.
+   */
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for gamma distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamGammaTestCase : public TestCase
+/**
+ * Test case for gamma distribution random variable stream generator
+ */
+class GammaTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  GammaTestCase ();
 
-  RandomVariableStreamGammaTestCase ();
-  virtual ~RandomVariableStreamGammaTestCase ();
-
-  double ChiSquaredTest (Ptr<GammaRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamGammaTestCase::RandomVariableStreamGammaTestCase ()
-  : TestCase ("Gamma Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamGammaTestCase::~RandomVariableStreamGammaTestCase ()
+GammaTestCase::GammaTestCase ()
+  : TestCaseBase ("Gamma Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamGammaTestCase::ChiSquaredTest (Ptr<GammaRandomVariable> n)
+GammaTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has alpha equal to one and beta
   // equal to one, which are their default values for this
@@ -1858,61 +1576,31 @@
   double alpha = 1.0;
   double beta = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gamma_P (range[i + 1], alpha, beta) - gsl_cdf_gamma_P (range[i], alpha, beta);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamGammaTestCase::DoRun (void)
+GammaTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<GammaRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<GammaRandomVariable> n = CreateObject<GammaRandomVariable> ();
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double alpha = 5.0;
   double beta = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<GammaRandomVariable> x = CreateObject<GammaRandomVariable> ();
@@ -1920,13 +1608,7 @@
   x->SetAttribute ("Beta", DoubleValue (beta));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // gammaly distributed random variable is equal to
@@ -1936,48 +1618,43 @@
   double expectedMean = alpha * beta;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic gamma distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamGammaAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic gamma distribution random variable stream generator
+ */
+class GammaAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamGammaAntitheticTestCase ();
-  virtual ~RandomVariableStreamGammaAntitheticTestCase ();
+  // Constructor
+  GammaAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<GammaRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamGammaAntitheticTestCase::RandomVariableStreamGammaAntitheticTestCase ()
-  : TestCase ("Antithetic Gamma Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamGammaAntitheticTestCase::~RandomVariableStreamGammaAntitheticTestCase ()
+GammaAntitheticTestCase::GammaAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Gamma Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamGammaAntitheticTestCase::ChiSquaredTest (Ptr<GammaRandomVariable> n)
+GammaAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has alpha equal to one and beta
   // equal to one, which are their default values for this
@@ -1985,65 +1662,31 @@
   double alpha = 1.0;
   double beta = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gamma_P (range[i + 1], alpha, beta) - gsl_cdf_gamma_P (range[i], alpha, beta);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamGammaAntitheticTestCase::DoRun (void)
+GammaAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<GammaRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<GammaRandomVariable> n = CreateObject<GammaRandomVariable> ();
-
-      // Make this generate antithetic values.
-      n->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double alpha = 5.0;
   double beta = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<GammaRandomVariable> x = CreateObject<GammaRandomVariable> ();
@@ -2055,13 +1698,7 @@
   x->SetAttribute ("Beta", DoubleValue (beta));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // gammaly distributed random variable is equal to
@@ -2071,48 +1708,43 @@
   double expectedMean = alpha * beta;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for Erlang distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamErlangTestCase : public TestCase
+/**
+ * Test case for Erlang distribution random variable stream generator
+ */
+class ErlangTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  ErlangTestCase ();
 
-  RandomVariableStreamErlangTestCase ();
-  virtual ~RandomVariableStreamErlangTestCase ();
-
-  double ChiSquaredTest (Ptr<ErlangRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamErlangTestCase::RandomVariableStreamErlangTestCase ()
-  : TestCase ("Erlang Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamErlangTestCase::~RandomVariableStreamErlangTestCase ()
+ErlangTestCase::ErlangTestCase ()
+  : TestCaseBase ("Erlang Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamErlangTestCase::ChiSquaredTest (Ptr<ErlangRandomVariable> n)
+ErlangTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has k equal to one and lambda
   // equal to one, which are their default values for this
@@ -2123,61 +1755,31 @@
   // Note that Erlang distribution is equal to the gamma distribution
   // when k is an iteger, which is why the gamma distribution's cdf
   // function can be used here.
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gamma_P (range[i + 1], k, lambda) - gsl_cdf_gamma_P (range[i], k, lambda);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamErlangTestCase::DoRun (void)
+ErlangTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ErlangRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ErlangRandomVariable> n = CreateObject<ErlangRandomVariable> ();
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   uint32_t k = 5;
   double lambda = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ErlangRandomVariable> x = CreateObject<ErlangRandomVariable> ();
@@ -2185,13 +1787,7 @@
   x->SetAttribute ("Lambda", DoubleValue (lambda));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Erlangly distributed random variable is equal to
@@ -2201,48 +1797,43 @@
   double expectedMean = k * lambda;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic Erlang distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamErlangAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic Erlang distribution random variable stream generator
+ */
+class ErlangAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamErlangAntitheticTestCase ();
-  virtual ~RandomVariableStreamErlangAntitheticTestCase ();
+  // Constructor
+  ErlangAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<ErlangRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamErlangAntitheticTestCase::RandomVariableStreamErlangAntitheticTestCase ()
-  : TestCase ("Antithetic Erlang Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamErlangAntitheticTestCase::~RandomVariableStreamErlangAntitheticTestCase ()
+ErlangAntitheticTestCase::ErlangAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Erlang Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamErlangAntitheticTestCase::ChiSquaredTest (Ptr<ErlangRandomVariable> n)
+ErlangAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has k equal to one and lambda
   // equal to one, which are their default values for this
@@ -2253,65 +1844,31 @@
   // Note that Erlang distribution is equal to the gamma distribution
   // when k is an iteger, which is why the gamma distribution's cdf
   // function can be used here.
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gamma_P (range[i + 1], k, lambda) - gsl_cdf_gamma_P (range[i], k, lambda);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamErlangAntitheticTestCase::DoRun (void)
+ErlangAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ErlangRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ErlangRandomVariable> n = CreateObject<ErlangRandomVariable> ();
-
-      // Make this generate antithetic values.
-      n->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   uint32_t k = 5;
   double lambda = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ErlangRandomVariable> x = CreateObject<ErlangRandomVariable> ();
@@ -2323,13 +1880,7 @@
   x->SetAttribute ("Lambda", DoubleValue (lambda));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Erlangly distributed random variable is equal to
@@ -2339,40 +1890,41 @@
   double expectedMean = k * lambda;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for Zipf distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamZipfTestCase : public TestCase
+/**
+ * Test case for Zipf distribution random variable stream generator
+ */
+class ZipfTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamZipfTestCase ();
-  virtual ~RandomVariableStreamZipfTestCase ();
+  // Constructor
+  ZipfTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamZipfTestCase::RandomVariableStreamZipfTestCase ()
-  : TestCase ("Zipf Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamZipfTestCase::~RandomVariableStreamZipfTestCase ()
+ZipfTestCase::ZipfTestCase ()
+  : TestCaseBase ("Zipf Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamZipfTestCase::DoRun (void)
+ZipfTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   uint32_t n = 1;
   double alpha = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ZipfRandomVariable> x = CreateObject<ZipfRandomVariable> ();
@@ -2380,13 +1932,7 @@
   x->SetAttribute ("Alpha", DoubleValue (alpha));
 
   // Calculate the mean of these values.
-  double sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Zipfly distributed random variable is equal to
@@ -2419,40 +1965,41 @@
   double expectedMean = 1.0;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic Zipf distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamZipfAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic Zipf distribution random variable stream generator
+ */
+class ZipfAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamZipfAntitheticTestCase ();
-  virtual ~RandomVariableStreamZipfAntitheticTestCase ();
+  // Constructor
+  ZipfAntitheticTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamZipfAntitheticTestCase::RandomVariableStreamZipfAntitheticTestCase ()
-  : TestCase ("Antithetic Zipf Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamZipfAntitheticTestCase::~RandomVariableStreamZipfAntitheticTestCase ()
+ZipfAntitheticTestCase::ZipfAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Zipf Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamZipfAntitheticTestCase::DoRun (void)
+ZipfAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   uint32_t n = 1;
   double alpha = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ZipfRandomVariable> x = CreateObject<ZipfRandomVariable> ();
